
#ifndef BLQ_H
#define BLQ_H
 
/* ----------------------------------------------------------------------
  (c) 2011 Geodetic Observatory Pecny, http://www.pecny.cz (gnss@pecny.cz)
      Research Institute of Geodesy, Topography and Cartography
      Ondrejov 244, 251 65, Czech Republic

  Purpose: 
  Version: $Rev:$

  2013-03-29 /PV: created

-*/

#include <vector> 

#include "../newmat/newmat.h"

#include "gcoders/gcoder.h"
#include "gmodels/gotl.h"
#include "gall/gallotl.h"
#include "gutils/gtime.h"

using namespace std;

namespace gnut {

class t_blq : public t_gcoder {

 public:
   t_blq( string version = "", int sz = DEFAULT_BUFFER_SIZE );
  ~t_blq(){};

  virtual  int decode_head(char* buff, int sz,           vector<string>& errmsg);
  virtual  int decode_data(char* buff, int sz, int& cnt, vector<string>& errmsg);

 protected:
   double _lat;
   double _lon;
   string _site;
   Matrix _blqdata;

 private:

};

} // namespace

#endif
