
#ifndef GPPPMODEL_H
#define GPPPMODEL_H

/* ----------------------------------------------------------------------
  (c) 2011 Geodetic Observatory Pecny, http://www.pecny.cz (gnss@pecny.cz)
      Research Institute of Geodesy, Topography and Cartography
      Ondrejov 244, 251 65, Czech Republic

  Purpose: various PPP models
  Version: $ Rev: $

  2012-09-20 /PV: created

-*/

#include <string>
#include <map>
#include <cmath>

#include "gmodels/gsppmodel.h"
#include "gutils/gtypeconv.h"
#include "gmodels/gephplan.h"
#include "gall/gallobj.h"

using namespace std;

namespace gnut {   

class t_gpppmodel : public t_gsppmodel
{
 public:
   t_gpppmodel(string site,t_glog* glog, t_gsetbase* settings);
   t_gpppmodel() {};
   virtual ~t_gpppmodel();
   
   virtual double windUp(t_gtime& epoch, const string, const ColumnVector&, const ColumnVector&);
   virtual double cmpObs(t_gtime& epoch, t_gallpar& param, t_gsatdata&, bool phase, bool com);
   virtual double tropoDelay(t_gtime& epoch, t_gallpar& param, t_gtriple ell, t_gsatdata& satdata);

   virtual void setOBJ(t_gallobj* obj);
   
  protected:   
   map<string, double> _windUpTime;
   map<string, double> _windUpSum;
   t_gephplan          _ephplan;
   t_gallobj*          _gallobj;
   string              _grad_mf;
   
};

} // namespace

#endif //  GPPPMODEL_H
