
#ifndef GSPPMODEL_H
#define GSPPMODEL_H

/* ----------------------------------------------------------------------
  (c) 2011 Geodetic Observatory Pecny, http://www.pecny.cz (gnss@pecny.cz)
      Research Institute of Geodesy, Topography and Cartography
      Ondrejov 244, 251 65, Czech Republic

  Purpose: various SPP models
  Version: $ Rev: $

  2014-11-27 /PV: created

-*/

#include <string>
#include <map>
#include <cmath>

#include "gmodels/gmodel.h"

#include "../newmat/newmat.h"
#include "../newmat/newmatio.h"

#include "gset/gsetproc.h"
#include "gset/gsetrec.h"
#include "gutils/gsysconv.h"
#include "gutils/gnss.h"
#include "gmodels/ggmf.h"

using namespace std;

namespace gnut {   

class t_gsppmodel : public t_gmodel
{
 public:
   t_gsppmodel(string site,t_glog* glog, t_gsetbase* settings);
   t_gsppmodel() {};
  virtual ~t_gsppmodel();

   virtual int outlierDetect( vector<t_gsatdata>& data, SymmetricMatrix& Qx, const SymmetricMatrix&, const ColumnVector&, vector<GOBSTYPE>& obstypes);
   virtual double cmpObs(t_gtime& epoch, t_gallpar& param, t_gsatdata&, bool phase, bool com = false);
   virtual double tropoDelay(t_gtime& epoch, t_gallpar& param, t_gtriple ell, t_gsatdata& satdata);   
   
 protected:
   double              _sigCodeGLO;       /**< Code sigma.  - GLONASS*/
   t_gtriple           _aprox_crd_xml;    /**< Approximate coordinates. */
   string              _trpModStr;
   string              _tropo_mf;
};

} // namespace

#endif //  GSPPMODEL_H
