
#ifndef GTIDE96_H
#define GTIDE96_H
 
/* ----------------------------------------------------------------------
  (c) 2011 Geodetic Observatory Pecny, http://www.pecny.cz (gnss@pecny.cz)
      Research Institute of Geodesy, Topography and Cartography
      Ondrejov 244, 251 65, Czech Republic

  Purpose: implements tides
  Version: $ Rev: $

  2012-11-05 /JD: created
 
 References:
    [1] D.D.McCarthy, IERS Technical Note 21, IERS Conventions 1996, July 1996
-*/

#include <vector>

#ifdef BMUTEX
#include <boost/thread/mutex.hpp>
#endif

#include "gutils/gconst.h"
#include "gutils/gtime.h"
#include "gutils/gtriple.h"
#include "gmodels/gephplan.h"
#include "gmodels/gtide.h"

using namespace std;

namespace gnut {   

// ----------
class t_gtide96 : public t_gtide {

 public:
  t_gtide96();
  virtual ~t_gtide96();

  virtual t_gtriple tide_searth(const t_gtime& epo, t_gtriple& xyz);        // solid earth tides
  virtual t_gtriple tide_pole();                                            // pole tides
  virtual t_gtriple load_ocean(const t_gtime& epoch, const string& site);   // ocean tide loading
  virtual t_gtriple load_atmosph();                                         // atmospheric tide loading

 protected:

};

} // namespace

#endif
