
#ifndef GPPPFLT_H
#define GPPPFLT_H

/* ----------------------------------------------------------------------
  (c) 2011 Geodetic Observatory Pecny, http://www.pecny.cz (gnss@pecny.cz)
      Research Institute of Geodesy, Topography and Cartography
      Ondrejov 244, 251 65, Czech Republic

  Purpose: implements ppp client
  Version: $ Rev: $

  2011-06-06 /PV: created
  2011-06-06 /JD: revised for multi-threading

-*/

#include <fstream>

#include "gproc/gppp.h"
#include "gproc/gsppflt.h"
#include "gall/gallfltmat.h"

namespace gnut {

class t_gpppflt : public t_gppp,
                  public t_gsppflt
{
 public:
   t_gpppflt();      
   t_gpppflt(string mark, t_gsetbase* set);
  ~t_gpppflt();

   virtual int processBatch(const t_gtime& beg, const t_gtime& end);
   
   void debugPrint();
 protected:

   virtual int    _processEpoch(const t_gtime& runEpoch);
   virtual int    _addObsL(t_gsatdata& satdata, unsigned int& iobs, t_gtriple& ell, Matrix& A, ColumnVector& l, DiagonalMatrix& P);   
   virtual void   _predict();
   virtual int    _satPos(t_gtime&, t_gsatdata&);
//   virtual int    _prepareData();
   virtual int    _apply_tides(t_gtime& _epoch, t_gtriple& xRec);
   void           _syncAmb();
   void           _setOut();
   
   t_giof* _flt;
   t_giof* _smt;
   
// Models   
   t_randomwalk*       _grdStoModel;
   
// Update time for RDW processes
   virtual void        _timeUpdate(const t_gtime& epo);

// Data for smoothing (Rauch-Tung-Striebel algorithm)   
   t_gfltmat         _fltdata;
   t_gallfltmat      _vfltdata;
   virtual void      _backflt();

// Intervals for reseting parameters
   int               _reset_amb;
   int               _reset_par;      
   
};

} // namespace

#endif // GPPPFLT_H
