
/* ----------------------------------------------------------------------
 * G-Nut - GNSS software development library
 * 
  (c) 2011 Geodetic Observatory Pecny, http://www.pecny.cz (gnss@pecny.cz)
      Research Institute of Geodesy, Topography and Cartography
      Ondrejov 244, 251 65, Czech Republic

  This file is part of the G-Nut C++ library.
 
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License as
  published by the Free Software Foundation; either version 3 of
  the License, or (at your option) any later version.
 
  This library is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
  General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, see <http://www.gnu.org/licenses>.

-*/

#include "gprod/gprodcrd.h"

using namespace std;

namespace gnut {

// constructor
// ----------
t_gprodcrd::t_gprodcrd(const t_gtime& t, shared_ptr<t_gobj> pt)
 : t_gprod(t, pt)
{ 
   gtrace("t_gprodcrd::t_gprodcrd");
   
   id_type(POS);
   id_group(GRP_PRODUCT);   
}

// destructor
// --------------
t_gprodcrd::~t_gprodcrd()
{
}


// add xyz
// --------------------------
void t_gprodcrd::xyz(const t_gtriple& xyz)
{
   _xyz = xyz;
}

// get xyz
// --------------------------
t_gtriple t_gprodcrd::xyz() const
{
   return _xyz;
}

// add xyz rms
// -------------------------
void t_gprodcrd::xyz_rms(const t_gtriple& xyz_rms)
{
   _xyz_rms = xyz_rms;
}

// get xyz rms
// -------------------------
t_gtriple t_gprodcrd::xyz_rms() const
{
   return _xyz_rms;
}

} // namespace
