
#ifndef GPRODTRP_H
#define GPRODTRP_H 
 
/* ----------------------------------------------------------------------
  (c) 2011 Geodetic Observatory Pecny, http://www.pecny.cz (gnss@pecny.cz)
      Research Institute of Geodesy, Topography and Cartography
      Ondrejov 244, 251 65, Czech Republic

  Purpose: class storing tropospheric (ZTD+GRD) products
  Version: $Rev:$

  2011-03-25 /JD: created

-*/

#include <iostream>

#include "gprod/gprod.h"
#include "gmodels/gnwmbase.h"

using namespace std;

namespace gnut {

class t_gprodtrp : public t_gprod
{
 public:
   t_gprodtrp(const t_gtime& t, shared_ptr<t_gobj> pt = nullobj);
  ~t_gprodtrp();

//enum TRO_ENUM { ZTD, ZHD, ZWD, PRES, EPRE, TEMP, MTEMP, RELH, SHUM, IWV, DT, DE, DW }
//typedef map<TRO_ENUM, pair<double,double> t_map_met;
//typedef map<TRO_ENUM, double> t_map_rms;
//typedef map<string, pair<double,double> > t_map_met;

  void   met( const double& met, const double& rms = 0.0);
  double met() const;
  double rms() const;

  void   ztd( const double& ztd, const double& rms = 0.0);
  double ztd() const;
  double ztd_rms() const;

  void   grd( const double& grdN,       const double& grdE,
	      const double& rmsN = 0.0, const double& rmsE = 0.0);
   
  void   grd_N( const double& grd, const double& rms = 0.0);
  double grd_N() const;
  double grd_N_rms() const;

  void   grd_E( const double& grd, const double& rms = 0.0);
  double grd_E() const;
  double grd_E_rms() const;


 protected:
  double   _ztd;
  double   _grd_N;
  double   _grd_E;
  double   _ztd_rms;  
  double   _grd_N_rms;
  double   _grd_E_rms;

//t_map_met _met;
};

} // namespace

#endif
