
/* ----------------------------------------------------------------------
 * G-Nut - GNSS software development library
 * 
  (c) 2011 Geodetic Observatory Pecny, http://www.pecny.cz (gnss@pecny.cz)
      Research Institute of Geodesy, Topography and Cartography
      Ondrejov 244, 251 65, Czech Republic

  This file is part of the G-Nut C++ library.
 
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License as
  published by the Free Software Foundation; either version 3 of
  the License, or (at your option) any later version.
 
  This library is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
  General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, see <http://www.gnu.org/licenses>.

-*/

#include <math.h>
#include <iostream>

#include "gproj/gproj.h"
#include "gutils/gcommon.h"

using namespace std;

namespace gnut {


// Conversion from LatLon [deg] sphere to generic project projection, keeping the HEIGHT!
// ---------- 
t_gtriple t_gproj::ll2proj(const t_gtriple& latlon)
{
  gtrace("t_gproj::sph2lcc(t_gtriple)");

  t_gpair ll( latlon.gpair() );
  t_gpair xx = this->ll2proj(ll);
//cout << "GPROJ: XX = " << xx[0] << " " << xx[1] << " LL = " << ll[0] << " " << ll[1] << endl;
  t_gtriple xxh(xx[0], xx[1], latlon[2]);

  return xxh;
}

   
} // namespace
