
#ifndef GCFG_SOTHIS_H
#define GCFG_SOTHIS_H

/* ----------------------------------------------------------------------
  (c) 2011 Geodetic Observatory Pecny, http://www.pecny.cz (gnss@pecny.cz)
      Research Institute of Geodesy, Topography and Cartography
      Ondrejov 244, 251 65, Czech Republic

  Purpose: implements settings for GEB application
  Version: $ Rev: $

  2012-10-23 /JD: created

-*/

#include <string>
#include <cstring>
#include <iostream>
#include <iomanip>
#include <time.h> 
#include <signal.h>
#include <functional>
#include <numeric>

// BOOSTS DEPENDENT
#include <boost/thread/thread.hpp>

#ifdef BMUTEX
#include <boost/thread/mutex.hpp>
#endif

#include "gproc/gppp.h"
#include "gproc/gpppflt.h"
#include "gproc/gpreproc.h"
#include "gall/gallnav.h"
#include "gall/gallprec.h"
#include "gall/gallobs.h"
#include "gall/gallotl.h"
#include "gall/gallobj.h"
#include "gall/gallsurf.h"

#include "gio/gio.h"
#include "gio/glog.h"
#include "gio/gfile.h"
#include "gutils/gtime.h"
#include "gutils/gtypeconv.h"
#include "gcoders/gcoder.h"
#include "gcoders/rinexo.h"
#include "gcoders/rinexn.h"
#include "gcoders/rinexc.h"
#include "gcoders/sp3.h"
#include "gcoders/atx.h"
#include "gcoders/blq.h"
#include "gmodels/gpcv.h"
#include "gmodels/gbancroft.h"
#include "gdata/gdata.h"
#include "gdata/gsatdata.h"

#include "gset/gsetinp.h"
#include "gset/gsetout.h"
#include "gset/gsetproc.h"
#include "gset/gsetflt.h"
#include "gset/gsetrec.h"

using namespace std;
using namespace pugi;

namespace gnut {

class t_gcfg_sothis : public t_gsetgen,
                      public t_gsetinp,
                      public t_gsetout,
                      public t_gsetproc,
                      public t_gsetflt,
                      public t_gsetrec,
                      public t_gsetgnss
{

 public:
   t_gcfg_sothis();
  ~t_gcfg_sothis();

   void check();                                 // settings check
   void help();                                  // settings help

 protected:

 private:

};

} // namespace

#endif